#include "JSVMotor.h"

JSVMotor::JSVMotor(){
    MaxMotorSpeed = 150;
    MinMotorSpeed = 60;
	  MotorReversed = 0; 
}

JSVMotor::JSVMotor(uint8_t PWMPin, uint8_t DirPin, uint8_t MinSpeed, uint8_t MaxSpeed){
	//setting pins
	MotorPWMPin = PWMPin;
	MotorDirPin = DirPin;
	pinMode(MotorPWMPin,OUTPUT);
	pinMode(MotorDirPin,OUTPUT);
	MaxMotorSpeed = MaxSpeed;
	MinMotorSpeed = MinSpeed;
}

void JSVMotor::MotorForward(int Speed){
	analogWrite(MotorPWMPin,255-Speed);
  	digitalWrite(MotorDirPin,HIGH);
}
void JSVMotor::MotorBackward(int Speed){
	analogWrite(MotorPWMPin,Speed);
	digitalWrite(MotorDirPin,LOW); 
}
void JSVMotor::MotorSTOP(){
	digitalWrite(MotorPWMPin,LOW);
	digitalWrite(MotorDirPin,LOW);
}
void JSVMotor::ControlMotor(bool motordirection, int percentage){
	long Speed;
    if (MotorReversed){
    	motordirection = !motordirection;
	}
  	if(percentage==0){
    	MotorSTOP();
  	}
  	else{
  		Speed = ((percentage*(MaxMotorSpeed-MinMotorSpeed))/100+MinMotorSpeed);
		if(motordirection==1){
			MotorForward((int)Speed);
		}
		else{
			MotorBackward((int)Speed);
		}
	}
}

void JSVMotor::ReverseMotor(){
	MotorReversed = 1;
}
uint8_t JSVMotor::GetMaxMotorSpeed(){
	return MaxMotorSpeed;
}
void JSVMotor::SetMaxMotorSpeed(uint8_t NewMaxMotorSpeed){
	MaxMotorSpeed = NewMaxMotorSpeed;
}
uint8_t JSVMotor::GetMinMotorSpeed(){
	return MinMotorSpeed;
}
void JSVMotor::SetMinMotorSpeed(uint8_t NewMinMotorSpeed){
	MinMotorSpeed = NewMinMotorSpeed;
}

