#ifndef JSVMotor_h
#define JSVMotor_h

#include <Arduino.h>

//brief Class for DC Motor used for JSV Robot Billy (use with L293 with EN permanent ON and PWM on the Input legs)

class JSVMotor
{
  	protected:
      //initializing pincofiguration
      uint8_t MotorPWMPin = 200;
      uint8_t MotorDirPin = 200;
      uint8_t MaxMotorSpeed = 150;
      uint8_t MinMotorSpeed = 60;
      boolean MotorReversed = 0; 			//reverses the motors direction without having to change all the functions
	public:
		JSVMotor();
		JSVMotor(uint8_t PWMPin, uint8_t DirPin, uint8_t MinSpeed, uint8_t MaxSpeed);
		void ControlMotor(bool direction, int percentage);
		void ReverseMotor();
		uint8_t GetMinMotorSpeed();
		void SetMinMotorSpeed(uint8_t NewMinMotorSpeed); 
		uint8_t GetMaxMotorSpeed();
		void SetMaxMotorSpeed(uint8_t NewMaxMotorSpeed);  
	private:
	    void MotorForward(int Speed);
	    void MotorBackward(int Speed);
	    void MotorSTOP();
};

#endif
